#include "module.h" 
#include "main.h" 

#include "language.c" 
#include "mysql.c" 
#include "botserv.c"
#include "ircd.c"


int AnopeInit(int argc, char **argv) {
    Message *m;
    EvtHook *hook;


#ifndef USE_MYSQL 
    alog("[%s] MYSQL is not enabled. This module requires MYSQL !", MODNAME);
    alog("[%s] Module not loaded.", MODNAME);
    return MOD_STOP;
#endif 
    if (!do_mysql) {
        alog("[%s] MYSQL is not configured. Please edit your services.conf .", MODNAME);
        alog("[%s] Module not loaded.", MODNAME);
        return MOD_STOP;
    }

    /* activate mysql connection and stop if failed */
    /* error messages are logged by mydb_init()     */
    if (mydb_init()) return MOD_STOP;

    /* load language files */
    mod_lang_init();

    m = createMessage("PRIVMSG", do_on_privmsg);
    moduleAddMessage(m, MOD_HEAD);
    m = createMessage("NICK", do_on_nickchange);
    moduleAddMessage(m, MOD_HEAD);
    m = createMessage("KICK", do_on_kick);
    moduleAddMessage(m, MOD_HEAD);
    m = createMessage("QUIT", do_on_quit);
    moduleAddMessage(m, MOD_HEAD);


    if (UseTokens) {   /* unrealircd only */
        m = createMessage("!", do_on_privmsg);
        moduleAddMessage(m, MOD_HEAD);
    	m = createMessage("&", do_on_nickchange);
    	moduleAddMessage(m, MOD_TAIL);
	m = createMessage("H", do_on_kick);
	moduleAddMessage(m, MOD_HEAD);
	m = createMessage(",", do_on_quit);
	moduleAddMessage(m, MOD_HEAD);
    }

    /*  int functioname(int argc, char **argv); */
    hook = createEventHook(EVENT_NEWNICK, do_on_connect);
    moduleAddEventHook(hook);
    hook = createEventHook(EVENT_JOIN_CHANNEL, do_on_join);
    moduleAddEventHook(hook);
    hook = createEventHook(EVENT_PART_CHANNEL, do_on_part);
    moduleAddEventHook(hook);

    moduleAddAuthor(AUTHOR);
    moduleAddVersion(VERSION);
    return MOD_CONT;
}

void AnopeFini(void)
{
    /* closing mysql connection */
    mysql_close(mymysql);
    /* unloading language files */
    mod_lang_unload();
    /* module unloading */
}


